<template>
    <div>
        <h1>Lexique</h1>
        <table class="uk-table uk-table-divider">
            <thead>
                <tr>
                    <td>Français</td>
                    <td>Hanyu</td>
                    <td>Pinyin</td>
                    <td>Kanji</td>
                    <td>Romanji</td>
                    <td>Hangeul</td>
                    <td>Romanisation coréen</td>
                    <td>Description</td>
                    <td v-if="this.$auth.isRoleAutorise('Admin')">Modifier</td>
                    <td v-if="this.$auth.isRoleAutorise('Admin')">Supprimer</td>
                </tr>
            </thead>

            <tr v-for="element in elements" :key="element.francais">
                <td>{{ element.original }}</td>
                <td>{{ element.hanyu }}</td>
                <td>{{ element.pinyin }}</td>
                <td>{{ element.kanji }}</td>
                <td>{{ element.romanji }}</td>
                <td>{{ element.hangeul }}</td>
                <td>{{ element.romanisationCoreen }}</td>
                <td>{{ element.description }}</td>
                <td>
                    <span
                        class="uk-margin-small-right"
                        uk-icon="icon: file-edit; ratio: 1"
                        @click="modifier(element)"
                    ></span>
                </td>
                <td>
                    <span
                        class="uk-margin-small-right"
                        uk-icon="icon: close; ratio: 1"
                        @click="supprimer(element.id)"
                    ></span>
                </td>
            </tr>
        </table>

        <div
            v-if="this.$auth.isRoleAutorise('Admin')"
            class="uk-margin"
            uk-margin
        >
            <div uk-form-custom="target: true">
                <input type="file" ref="import" @change="ajouterFichier" />
                <input
                    class="uk-input uk-form-width-medium"
                    type="text"
                    placeholder="Choisir fichier"
                    disabled
                />
            </div>
            <button class="uk-button uk-button-default" @click="importer">
                Importer
            </button>

            <input
                class="uk-input"
                type="text"
                placeholder="original"
                v-model="original"
            />
            <input
                class="uk-input"
                type="text"
                placeholder="hanyu"
                v-model="hanyu"
            />
            <input
                class="uk-input"
                type="text"
                placeholder="pinyin"
                v-model="pinyin"
            />
            <input
                class="uk-input"
                type="text"
                placeholder="kanji"
                v-model="kanji"
            />
            <input
                class="uk-input"
                type="text"
                placeholder="romanji"
                v-model="romanji"
            />
            <input
                class="uk-input"
                type="text"
                placeholder="hangeul"
                v-model="hangeul"
            />
            <input
                class="uk-input"
                type="text"
                placeholder="romanisationCoreen"
                v-model="romanisationCoreen"
            />
            <input
                class="uk-input"
                type="text"
                placeholder="description"
                v-model="description"
            />
            <button class="uk-button uk-button-default" @click="enregister()">
                Enregister
            </button>
        </div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import Axios from '@/auth/axiosAuth';
@Component
export default class Lexique extends Vue {
    private elements: any[] = [];
    private fichier: File = null;

    private idElement = '';
    private original = '';
    private hanyu = '';
    private pinyin = '';
    private kanji = '';
    private romanji = '';
    private hangeul = '';
    private romanisationCoreen = '';
    private description = '';

    $refs: {
        import: HTMLFormElement;
    };

    beforeRouteEnter(to, from, next) {
        next(vm =>
            Axios.get('lexique/', response => (vm.elements = response.data))
        );
    }

    public ajouterFichier() {
        this.fichier = this.$refs.import.files[0];
    }

    public importer() {
        const formData = new FormData();
        formData.append('fichier', this.fichier);
        Axios.postFile(
            'lexique/',
            reponse =>
                reponse.data.forEach(element => {
                    this.elements.push(element);
                }),
            formData
        );
        this.fichier = null;
    }

    public supprimer(idElement: string) {
        Axios.delete('lexique/' + idElement, response =>
            this.elements.splice(
                this.elements.map(element => element.id).indexOf(idElement),
                1
            )
        );
    }

    public modifier(element: any) {
        this.idElement = element.id;
        this.original = element.original;
        this.hanyu = element.hanyu;
        this.pinyin = element.pinyin;
        this.kanji = element.kanji;
        this.romanji = element.romanji;
        this.hangeul = element.hangeul;
        this.romanisationCoreen = element.romanisationCoreen;
        this.description = element.description;
    }

    public enregister(element: any) {
        const formData = new FormData();
        formData.append('id', this.idElement);
        formData.append('original', this.original);
        formData.append('hanyu', this.hanyu);
        formData.append('pinyin', this.pinyin);
        formData.append('kanji', this.kanji);
        formData.append('romanji', this.romanji);
        formData.append('hangeul', this.hangeul);
        formData.append('romanisationCoreen', this.romanisationCoreen);
        formData.append('description', this.description);
        Axios.put(
            'lexique/',
            response => {
                this.elements.splice(
                    this.elements
                        .map(element => element.id)
                        .indexOf(this.idElement),
                    1
                );
                this.elements.push(response.data);
                this.idElement = '';
                this.original = '';
                this.hanyu = '';
                this.pinyin = '';
                this.kanji = '';
                this.romanji = '';
                this.hangeul = '';
                this.romanisationCoreen = '';
                this.description = '';
            },
            formData
        );
    }
}
</script>
